#include <libguile.h>
#include <libguile/__scm.h>

#include <g-wrap.h>
#include <ncurses/curses.h>
#include "curses.h"

void short_print(short* obj, GWSCM port, int writingp)
{
  char buf[7];
  if(!obj)
  {
	gw_puts("NULL", port); return;
  };
  sprintf(buf, "%i", *obj);
  gw_puts(buf, port);
  if(!writingp)
  {
	gw_puts("\n", port);
  };
};

void chtype_print(chtype* obj, GWSCM port, int writingp)
{
  char buf[11];
  if(!obj)
  {
	gw_puts("NULL", port); return;
  };
  sprintf(buf, "0x%x", *obj);
  gw_puts(buf, port);
  if(!writingp)
  {
	gw_puts("\n", port);
  };
};

void attr_t_print(attr_t* obj, GWSCM port, int writingp)
{
  chtype_print(obj, port, writingp);
};

/* I`m not sure... */
void short_free(short* obj)
{
  if(obj) free(obj);
};

void chtype_free(chtype* obj)
{
  if(obj) free(obj);
};

void attr_t_free(attr_t* obj)
{
  if(obj) free(obj);
};

int short_eq(short* a, short *b)
{
  if(!a || !b)
  {
	return (a == b);
  };
  if(*a != *b)
  {
	return 0;
  };
  return 1;
};

int chtype_eq(chtype* a, chtype *b)
{
  if(!a || !b)
  {
	return (a == b);
  };
  if(*a != *b)
  {
	return 0;
  };
  return 1;
};

int attr_t_eq(attr_t* a, attr_t* b)
{
  return chtype_eq(a, b);
};

SCM short2scm(short num)
{
  return SCM_MAKINUM(num);
};

short scm2short(SCM scm)
{
  return SCM_INUM(scm);
};

SCM is_short(SCM scm)
{
  if(SCM_INUMP(scm) && gh_exact_p(scm) && 
	 SCM_INUM(scm) < 32768 && SCM_INUM(scm) > -32768)
	return SCM_BOOL_T;
  return SCM_BOOL_F;
};

/* What to do with NULLs? Can we use SCM_ASSERT? */
short short_ref(short* ptr)
{
  if(ptr) return *ptr;
  return 0;
};

chtype chtype_ref(chtype* ptr)
{
  if(ptr) return *ptr;
  return 0;
};

attr_t attr_t_ref(attr_t* ptr)
{
  if(ptr) return *ptr;
  return 0;
};

int int_ref(int* ptr)
{
  if(ptr) return *ptr;
  return 0;
};

short* make_short()
{
  return (short *)malloc(sizeof(short));
};

chtype* make_chtype()
{
  return (chtype *)malloc(sizeof(chtype));
};

attr_t* make_attr_t()
{
  return (attr_t *)malloc(sizeof(attr_t));
};

int* make_int()
{
  return (int *)malloc(sizeof(int));
};

void short_set(short* ptr, short val)
{
  if(ptr) *ptr = val;
};

void chtype_set(chtype* ptr, chtype val)
{
  if(ptr) *ptr = val;
};

void attr_t_set(attr_t* ptr, attr_t val)
{
  if(ptr) *ptr = val;
};

void int_set(int* ptr, int val)
{
  if(ptr) *ptr = val;
};
